// src/devcenter-app-instance-v1-app-instance-app-instances.universal.ts
import { transformError as sdkTransformError } from "@wix/sdk-runtime/transform-error";
import {
  renameKeysFromSDKRequestToRESTRequest,
  renameKeysFromRESTResponseToSDKResponse
} from "@wix/sdk-runtime/rename-all-nested-keys";

// src/devcenter-app-instance-v1-app-instance-app-instances.http.ts
import { toURLSearchParams } from "@wix/sdk-runtime/rest-modules";
import { transformRESTTimestampToSDKTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformPaths } from "@wix/sdk-runtime/transformations/transform-paths";
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveComWixpressMarketAimApiAppInstanceServiceUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/app-instance-manager-webapp",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "wixapis.com": [
      {
        srcPath: "/apps",
        destPath: ""
      }
    ],
    "dev._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      },
      {
        srcPath: "/api/v1/instance",
        destPath: "/v1/instance"
      },
      {
        srcPath: "/api/v1/scripts",
        destPath: "/v1/scripts"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/app-instance-manager",
        destPath: ""
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_app-management_app-instances";
function getAppInstance(payload) {
  function __getAppInstance({ host }) {
    const metadata = {
      entityFqdn: "wix.devcenter.app_instance.v1.app_instance",
      method: "GET",
      methodFqn: "com.wixpress.market.aim.api.AppInstanceService.GetAppInstance",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressMarketAimApiAppInstanceServiceUrl({
        protoPath: "/v1/instance",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload),
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "instance.billing.freeTrialInfo.endDate" }]
        }
      ])
    };
    return metadata;
  }
  return __getAppInstance;
}

// src/devcenter-app-instance-v1-app-instance-app-instances.universal.ts
var PaymentCycle = /* @__PURE__ */ ((PaymentCycle2) => {
  PaymentCycle2["NO_CYCLE"] = "NO_CYCLE";
  PaymentCycle2["MONTHLY"] = "MONTHLY";
  PaymentCycle2["YEARLY"] = "YEARLY";
  PaymentCycle2["ONE_TIME"] = "ONE_TIME";
  PaymentCycle2["TWO_YEARS"] = "TWO_YEARS";
  PaymentCycle2["THREE_YEARS"] = "THREE_YEARS";
  PaymentCycle2["FOUR_YEARS"] = "FOUR_YEARS";
  PaymentCycle2["FIVE_YEARS"] = "FIVE_YEARS";
  return PaymentCycle2;
})(PaymentCycle || {});
var FreeTrialStatus = /* @__PURE__ */ ((FreeTrialStatus2) => {
  FreeTrialStatus2["UNKNOWN_STATUS"] = "UNKNOWN_STATUS";
  FreeTrialStatus2["IN_PROGRESS"] = "IN_PROGRESS";
  FreeTrialStatus2["ENDED"] = "ENDED";
  FreeTrialStatus2["NOT_AVAILABLE"] = "NOT_AVAILABLE";
  return FreeTrialStatus2;
})(FreeTrialStatus || {});
var FreeTrialPeriod = /* @__PURE__ */ ((FreeTrialPeriod2) => {
  FreeTrialPeriod2["FREE_TRIAL_PERIOD_UNKNOWN"] = "FREE_TRIAL_PERIOD_UNKNOWN";
  FreeTrialPeriod2["DURING_FREE_TRIAL"] = "DURING_FREE_TRIAL";
  FreeTrialPeriod2["NOT_DURING_FREE_TRIAL"] = "NOT_DURING_FREE_TRIAL";
  return FreeTrialPeriod2;
})(FreeTrialPeriod || {});
var ReactivationReason = /* @__PURE__ */ ((ReactivationReason2) => {
  ReactivationReason2["REACTIVATION_REASON_UNKNOWN"] = "REACTIVATION_REASON_UNKNOWN";
  ReactivationReason2["AUTO_RENEW_TURNED_ON"] = "AUTO_RENEW_TURNED_ON";
  return ReactivationReason2;
})(ReactivationReason || {});
var ResolutionMethod = /* @__PURE__ */ ((ResolutionMethod2) => {
  ResolutionMethod2["QUERY_PARAM"] = "QUERY_PARAM";
  ResolutionMethod2["SUBDOMAIN"] = "SUBDOMAIN";
  ResolutionMethod2["SUBDIRECTORY"] = "SUBDIRECTORY";
  return ResolutionMethod2;
})(ResolutionMethod || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function getAppInstance2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = renameKeysFromSDKRequestToRESTRequest({});
  const reqOpts = getAppInstance(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return renameKeysFromRESTResponseToSDKResponse(result.data);
  } catch (err) {
    const transformedError = sdkTransformError(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
export {
  FreeTrialPeriod,
  FreeTrialStatus,
  PaymentCycle,
  ReactivationReason,
  ResolutionMethod,
  WebhookIdentityType,
  getAppInstance2 as getAppInstance
};
//# sourceMappingURL=index.typings.mjs.map